UNIT CustomDraw;

INTERFACE

USES CommCtrl, Windows;

CONST NM_CUSTOMDRAW = NM_FIRST-12; // sub code of WM_NOTIFY

// The following values were taken from commtrl.h, since they aren't currently part
// of CommCtrl.pas.

    //==================== CUSTOM DRAW ==========================================

    // custom draw return flags
    // values under = $00010000 are reserved for global custom draw values.
    // above that are for specific controls
    CDRF_DODEFAULT          = $00000000;
    CDRF_NEWFONT            = $00000002;
    CDRF_SKIPDEFAULT        = $00000004;

    CDRF_NOTIFYPOSTPAINT    = $00000010;
    CDRF_NOTIFYITEMDRAW     = $00000020;
    CDRF_NOTIFYPOSTERASE    = $00000040;
    CDRF_NOTIFYITEMERASE    = $00000080;

    // drawstage flags
    // values under = $00010000 are reserved for global custom draw values.
    // above that are for specific controls
    CDDS_PREPAINT           = $00000001;
    CDDS_POSTPAINT          = $00000002;
    CDDS_PREERASE           = $00000003;
    CDDS_POSTERASE          = $00000004;
    // the = $000010000 bit means it's individual item specific
    CDDS_ITEM               = $00010000;
    CDDS_ITEMPREPAINT       = (CDDS_ITEM OR CDDS_PREPAINT);
    CDDS_ITEMPOSTPAINT      = (CDDS_ITEM OR CDDS_POSTPAINT);
    CDDS_ITEMPREERASE       = (CDDS_ITEM OR CDDS_PREERASE);
    CDDS_ITEMPOSTERASE      = (CDDS_ITEM OR CDDS_POSTERASE);

    // itemState flags (compare with ODS_ constants)
    CDIS_SELECTED           = $0001;
    CDIS_GRAYED             = $0002;
    CDIS_DISABLED           = $0004;
    CDIS_CHECKED            = $0008;
    CDIS_FOCUS              = $0010;
    CDIS_DEFAULT            = $0020;
    CDIS_HOT                = $0040;

TYPE PNMCustomDraw = ^TNMCustomDraw;
     TNMCustomDraw = RECORD
                       hdr         : TNMHdr;
                       dwDrawStage : DWORD;  // see above
                       hdc         : HDC;    // drawing area for the specific item
                       rc          : TRect;  // the enclosing rect for the specific item
                       dwItemSpec  : DWORD;  // item number in the control
                       uItemState  : UINT;   // see above
                       lItemlParam : LPARAM; // item specific data
                     END;
     PNMTVCustomDraw = ^TNMTVCustomDraw;
     TNMTVCustomDraw = RECORD
                         nmcd : TNMCustomDraw;
                         clrText   : COLORREF;
                         clrTextBk : COLORREF;
                       END;

IMPLEMENTATION

END.

